// AnimatorDoc.h : interface of the CAnimatorDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ANIMATORDOC_H__7F4F0549_BCF9_11D1_87D4_00A0C9062ECB__INCLUDED_)
#define AFX_ANIMATORDOC_H__7F4F0549_BCF9_11D1_87D4_00A0C9062ECB__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#include "vrmlparse.h"
#include "Dde.h"
#include "DDEML.h"

#include "BrowserControl.h"

class CAnimatorDoc : public CDocument
{
protected: // create from serialization only
	CAnimatorDoc();
	DECLARE_DYNCREATE(CAnimatorDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAnimatorDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CAnimatorDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	CBrowserControl m_bcDlg;

	nodelist* m_pScene;
	BOOL m_bLoop;
	double m_dLength;
	char* m_CurrentFilename;

	double m_dStillPoint;

	CString m_FileVRML;
	CString m_FileTemplate;
	DWORD m_dwPidInst;

	void WriteVRML( const char* );
	void WriteTemplate( const char*, const char*, float time );
	void SendURL( const char*, BOOL newwindow = FALSE );
	void UpdateBrowser( float time = -1.0f );
	void SetStillPoint( float time = -1.0f );

	void SaveAnimation( LPCTSTR );
	void LoadAnimation( LPCTSTR );

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CAnimatorDoc)
	afx_msg void OnFileOpen();
	afx_msg void OnFileWriteVRML();
	afx_msg void OnFileParams();
	afx_msg void OnFileWriteVRMLAs();
	afx_msg void OnUpdateFileWriteVRML(CCmdUI* pCmdUI);
	afx_msg void OnUpdate();
	afx_msg void OnFileSaveAs();
	afx_msg void OnFileLoad();
	afx_msg void OnUpdateFileLoad(CCmdUI* pCmdUI);
	afx_msg void OnFileBrowser();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#define UPDATE_NEW_VRML            1
#define UPDATE_EDIT_FIELD          2
#define UPDATE_PARAMETER_CHANGED   3
#define UPDATE_CLOSE_ALL          4

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ANIMATORDOC_H__7F4F0549_BCF9_11D1_87D4_00A0C9062ECB__INCLUDED_)
