#ifndef _EDITEDFIELD_H
#define _EDITEDFIELD_H

#include "stdafx.h"
#include "Animator.h"
#include "AnimatorDoc.h"
#include "Curve.h"

#include "vrmlparse.h"
#include "parse.tab.h"

#define MAX_CONTROL_POINTS    512

class CPlotView;

class CEditedField : public CObject
{
public:
	static int editedFieldCount;
	static CEditedField* listHead;
	static int interpCounter;
	CEditedField* next;
	CEditedField* prev;

	CAnimatorDoc* pDoc;
	field* pField;

	int nCurveCount;
	char** pCurveNames;
	COLORREF* pCurveColors;
	CCurve** pCurveCurves;
	int nSelectedCurve;

	int* nControl;
	double** xControl;
	double** yControl;

	int nDragPoint;

	double dyMin, dyMax, dxMin, dxMax;
	int nyMin, nyMax, nxMin, nxMax;

	static void Reset( void );
	static CEditedField* GetEditedField( field* f );
	static BOOL IsFieldEditable( field* f );
	static void SetLength( double );
	static void SaveAllCurves( FILE* );
	static void LoadAllCurves( FILE*, CAnimatorDoc* );
	void SaveCurves( FILE* );
	static field* FindPathname( char*, nodelist* );


	static void WriteAllVRML( FILE* );
	void WriteVRML( FILE* );

	CEditedField( field* f, CAnimatorDoc* );
	~CEditedField();

	void Draw( CDC* pDC, int xoffset, int yoffset, int width, int height,
		double xstill = -1.0 );
	void ChooseCurve( int );
	void ChooseType( int );

	double GetXFraction( double );
	CPoint MapToPoint( double, double );
	void MapToCurve( CPoint, double*, double* );
	BOOL WithinGrid( const CPoint& );
	void MakeWithinGrid( CPoint* );

	void MouseDown( CPoint, UINT );
	void MouseDrag( CPoint );
	void MouseUp( CPoint );
};


#endif