// SelectView.cpp : implementation of the CSelectView class
//

#include "stdafx.h"
#include "Animator.h"

#include "AnimatorDoc.h"
#include "SelectView.h"
#include "BrowserSelectDialog.h"

#include "vrmlparse.h"
#include "parse.tab.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelectView

IMPLEMENT_DYNCREATE(CSelectView, CTreeView)

BEGIN_MESSAGE_MAP(CSelectView, CTreeView)
	//{{AFX_MSG_MAP(CSelectView)
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectView construction/destruction

CSelectView::CSelectView()
{
	// TODO: add construction code here

}

CSelectView::~CSelectView()
{
}

BOOL CSelectView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style |= TVS_HASLINES | TVS_HASBUTTONS | TVS_LINESATROOT;

	return CTreeView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSelectView drawing

void CSelectView::OnDraw(CDC* pDC)
{
	CAnimatorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

HDDEDATA CALLBACK DdeCallback( UINT uType, UINT uFmt, HCONV hconv, HSZ hsz1, HSZ hsz2,
					 HDDEDATA hdata, DWORD dwData1, DWORD dwData2 )
{
	switch( uType )
	{
	case XCLASS_BOOL:
		TRACE( "XCLASS_BOOL\n" );
		return FALSE;

	case XCLASS_DATA:
		TRACE( "XCLASS_DATA\n" );
		return NULL;

	case XCLASS_FLAGS:
		TRACE( "XCLASS_FLAGS\n" );
		return (struct HDDEDATA__ *)DDE_FACK;

	case XCLASS_NOTIFICATION:
		TRACE( "XCLASS_NOTIFICATION\n" );
		return NULL;
	}

	return NULL;
}

void CSelectView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();

	initialize_keyword_table();

	DWORD pidInst = 0;
	int ret = DdeInitialize( &pidInst, DdeCallback, CBF_FAIL_CONNECTIONS, 0 );
	switch ( ret )
	{
	case DMLERR_NO_ERROR:
		TRACE( "DMLERR_NO_ERROR\n" );
		break;
	case DMLERR_DLL_USAGE:
		TRACE( "DMLERR_DLL_USAGE\n" );
		break;
	case DMLERR_INVALIDPARAMETER:
		TRACE( "DMLERR_INVALIDPARAMETER\n" );
		break;
	case DMLERR_SYS_ERROR:
		TRACE( "DMLERR_SYS_ERROR\n" );
		break;
	default:
		TRACE( "DMLERR: other %d\n", ret );
		break;
	}

	CAnimatorDoc* pDoc = (CAnimatorDoc*)GetDocument();
	pDoc->m_dwPidInst = pidInst;

	return;

}


/////////////////////////////////////////////////////////////////////////////
// CSelectView diagnostics

#ifdef _DEBUG
void CSelectView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CSelectView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

CAnimatorDoc* CSelectView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAnimatorDoc)));
	return (CAnimatorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSelectView message handlers

void CSelectView::BuildView( nodelist* nl, HTREEITEM parentitem, 
							TV_INSERTSTRUCT* tvinsert, field* parentfield,
							CString pathname )
{
	HTREEITEM newitem, thisitem;
	int recurse = 0;
	node* e = nl->node;
	field* f;
	CString itemtext;

	if ( parentfield )
	{
		itemtext = CString(keyword_table[parentfield->key]) + ": " + (e?keyword_table[e->type]:"NULL");

		/*itemtext = new char [strlen(keyword_table[parentfield->key]) + 3 + (e?strlen(keyword_table[e->type]):4)];
		strcpy( itemtext, keyword_table[parentfield->key] );
		strcat( itemtext, ": " );
		strcat( itemtext, e ? keyword_table[e->type] : "NULL" );*/
	}
	else
	{
		itemtext = CString( e ? keyword_table[e->type] : "NULL" );
	}

	CString newpath = pathname + "/" + ( e ? keyword_table[e->type] : "NULL" );

	if ( e && e->type != ROUTE )
	{
		CString mypath;

		if ( e->name && e->name[0] != '_' )
		{
			itemtext += " ";
			if ( nl->use )
			{
				itemtext += "(USE ";
				itemtext += e->name;
				itemtext += ")";
			}
			else
			{
				itemtext += e->name;
				newpath += " ";
				newpath += e->name;
			}
		}

		tvinsert->hParent = parentitem;
		tvinsert->item.cchTextMax = itemtext.GetLength() + 1;
		tvinsert->item.pszText = strdup( itemtext );
		tvinsert->item.lParam = (long)parentfield;
		tvinsert->item.state = parentfield ? 0 : TVIS_BOLD;
		if ( ! nl->use )
			tvinsert->item.state |= TVIS_EXPANDED;
		newitem = GetTreeCtrl().InsertItem( tvinsert );

		f = e->fields;
		while( f )
		{
			if ( f->pathname == NULL )
			{
				mypath = newpath + "/" + keyword_table[f->key];
				f->pathname = strdup( mypath );
			}
			else
				mypath = newpath;

			if ( f->realtype == MFNODE )
			{
				/* if the field contains multiple nodes, insert a tree item for the
				   field itself */

				tvinsert->hParent = newitem;
				tvinsert->item.cchTextMax = strlen( keyword_table[f->key] + 1 );
				tvinsert->item.pszText = keyword_table[f->key];
				tvinsert->item.lParam = (long)f;
				tvinsert->item.state = f ? 0 : TVIS_BOLD;
				tvinsert->item.state |= TVIS_EXPANDED;
				thisitem = GetTreeCtrl().InsertItem( tvinsert );
				BuildView( f->u.nl, thisitem, tvinsert, NULL, mypath );
			}
			else if ( f->nodetype == FT_NODE )
			{
				/* if the field contains a node, recur to insert it. */

				BuildView( f->u.nl, newitem, tvinsert, f, newpath );
			}
			else
			{
				/* if the field is something else, insert a tree item for it. */

				tvinsert->hParent = newitem;
				tvinsert->item.cchTextMax = strlen( keyword_table[f->key] + 1 );
				tvinsert->item.pszText = keyword_table[f->key];
				tvinsert->item.lParam = (long)f;
				tvinsert->item.state = f ? 0 : TVIS_BOLD;
				tvinsert->item.state |= TVIS_EXPANDED;
				thisitem = GetTreeCtrl().InsertItem( tvinsert );
			}

			f = f->next;
		}
	}

	if ( nl->next )
		BuildView( nl->next, parentitem, tvinsert, parentfield, pathname );

}

void CSelectView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CAnimatorDoc* pDoc = GetDocument();

	//TRACE( "--- starting traversal\n" );
	//traverse( pDoc->m_pScene, 0 );

	TV_INSERTSTRUCT tvinsert;
	tvinsert.hParent = NULL;
	tvinsert.hInsertAfter = TVI_LAST;
	tvinsert.item.mask = TVIF_TEXT | TVIF_PARAM | TVIF_STATE;
	tvinsert.item.hItem = NULL;
	tvinsert.item.state = TVIS_BOLD | TVIS_EXPANDED;
	tvinsert.item.stateMask = TVIS_BOLD | TVIS_EXPANDED;
	tvinsert.item.cchTextMax = 64;
	tvinsert.item.cChildren = 0;
	tvinsert.item.lParam = NULL;
	
	GetTreeCtrl().DeleteAllItems();

	if ( pDoc->m_pScene )
	{
		HTREEITEM item;
		CString pathname = "Scene";

		tvinsert.item.pszText = "Scene";
		item = GetTreeCtrl().InsertItem( &tvinsert );

		BuildView( pDoc->m_pScene, item, &tvinsert, NULL, pathname );
	}
	else
	{
		tvinsert.item.pszText = "No Scene Loaded";
		GetTreeCtrl().InsertItem( &tvinsert );
	}
}

void CSelectView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	unsigned int flags = TVHT_ONITEM;
	HTREEITEM theItem = GetTreeCtrl().HitTest( point, &flags );

	if ( theItem == NULL )
	{
		TRACE( "no item was clicked.\n" );
		return;
	}

	GetTreeCtrl().SelectItem( theItem );

	TV_ITEM get;
	get.hItem = theItem;
	get.mask = TVIF_HANDLE;
	if ( GetTreeCtrl().GetItem ( &get ) == 0 )
	{
		TRACE( "getitem failed\n" );
		return;
	}

	TRACE( "parameter is %d\n", get.lParam );

	if ( get.lParam )
	{
		field* f = (field *)get.lParam;
		if ( f->pathname )
			TRACE( "pathname is [%s]\n", f->pathname );
		else
			TRACE( "pathname is null\n" );

		CAnimatorDoc* pDoc = GetDocument();
		pDoc->UpdateAllViews( this, UPDATE_EDIT_FIELD, (CObject*)get.lParam );
	}

	//CTreeView::OnRButtonDown(nFlags, point);
}
